//////////
// item //
//////////
datablock ItemData(boneHammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./bonehammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Skeleton Hammer";
	iconName = "./icon_bonehammer";
	doColorShift = true;
	colorShiftColor = "0.68 0.69 0.58 1.000";

	 // Dynamic properties defined by the scripts
	image = bonehammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////

AddDamageType("Bonehammer",   '<bitmap:base/client/ui/CI/generic><bitmap:base/client/ui/CI/skull> %1',    '%2 <bitmap:base/client/ui/CI/generic><bitmap:base/client/ui/CI/skull> %1',0.75,1);

datablock ShapeBaseImageData(boneHammerImage)
{
   shapeFile = "./bonehammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.0 -0.1 0.1";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0";
    SpecialDamageType = "Bone";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   className = "tf2MeleeWeaponImage";

   // Projectile && Ammo.
   item = boneHammerItem;
   ammo = " ";
   projectile = hammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = bonehammerItem.colorShiftColor;
   
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = hammerProjectile;
   raycastExplosionBrickSound = bonehammersound;
   raycastExplosionPlayerSound = bloodhitsound;
   raycastDirectDamage = 33;
   raycastDirectDamageType = $DamageType::Bonehammer;
   
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]                  = "onActivate";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.05;
	stateTransitionOnTimeout[2]     = "FireA";
	
	stateName[3]                    = "FireA";
	stateTransitionOnTimeout[3]     = "FireB";
	stateTimeoutValue[3]            = 0.10;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                 = "activate";
	stateSound[3]			= boneswingsound;
	stateScript[3]                  = "onFireB";
	stateWaitForTimeout[3]		= true;

	stateName[4]                    = "FireB";
	stateTransitionOnTimeout[4]     = "Wait";
	stateTimeoutValue[4]            = 0.4;
	stateFire[4]                    = true;
	stateSequence[4]                 = "swing";
	stateAllowImageChange[4]        = false;
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	
	stateName[5]			= "Wait";
	stateTransitionOnTimeout[5]	= "CheckFire";
	stateTimeoutValue[5]		= 0.05;
	stateScript[5]			= "onStopFire";
	stateAllowImageChange[5]	= false;
	stateWaitForTimeout[5]		= true;

	stateName[6]			= "CheckFire";
	stateTransitionOnTriggerUp[6]	= "Ready";
};

function bonehammerImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(2,shiftto);

		%this.raycastExplosionBrickSound = bonehammerSound;
		%this.raycastExplosionPlayerSound = bloodhitSound;

	WeaponImage::onFire(%this, %obj, %slot);
}

function bonehammerImage::onFireB(%this, %obj, %slot)
{
	//%obj.playthread(2, shiftaway);
}

function bonehammerImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(2, shiftto);
}
